Index: sasmodels/jitter.py
===================================================================
--- sasmodels/jitter.py	(revision cff293936894836b818da65a243155cfab9fc5c4)
+++ sasmodels/jitter.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -51,5 +51,9 @@
 
 import numpy as np
-from numpy import pi, cos, sin, sqrt, exp, degrees, radians
+from numpy import pi, cos, sin, sqrt, exp, log, degrees, radians, arccos, arctan2
+
+# Too many complaints about variable names from pylint:
+#    a, b, c, u, v, x, y, z, dx, dy, dz, px, py, pz, R, Rx, Ry, Rz, ...
+# pylint: disable=invalid-name
 
 def draw_beam(axes, view=(0, 0), alpha=0.5, steps=25):
@@ -60,10 +64,10 @@
     #axes.scatter([0]*100,[0]*100,np.linspace(1, -1, 100), alpha=alpha)
 
-    u = np.linspace(0, 2 * np.pi, steps)
+    u = np.linspace(0, 2 * pi, steps)
     v = np.linspace(-1, 1, 2)
 
     r = 0.02
-    x = r*np.outer(np.cos(u), np.ones_like(v))
-    y = r*np.outer(np.sin(u), np.ones_like(v))
+    x = r*np.outer(cos(u), np.ones_like(v))
+    y = r*np.outer(sin(u), np.ones_like(v))
     z = 1.3*np.outer(np.ones_like(u), v)
 
@@ -90,9 +94,9 @@
     """Draw an ellipsoid."""
     a, b, c = size
-    u = np.linspace(0, 2 * np.pi, steps)
-    v = np.linspace(0, np.pi, steps)
-    x = a*np.outer(np.cos(u), np.sin(v))
-    y = b*np.outer(np.sin(u), np.sin(v))
-    z = c*np.outer(np.ones_like(u), np.cos(v))
+    u = np.linspace(0, 2 * pi, steps)
+    v = np.linspace(0, pi, steps)
+    x = a*np.outer(cos(u), sin(v))
+    y = b*np.outer(sin(u), sin(v))
+    z = c*np.outer(np.ones_like(u), cos(v))
     x, y, z = transform_xyz(view, jitter, x, y, z)
 
@@ -167,4 +171,5 @@
 
 def draw_box(axes, size, view):
+    """Draw a wireframe box at a particular view."""
     a, b, c = size
     x = a*np.array([+1, -1, +1, -1, +1, -1, +1, -1])
@@ -172,16 +177,16 @@
     z = c*np.array([+1, +1, +1, +1, -1, -1, -1, -1])
     x, y, z = transform_xyz(view, None, x, y, z)
-    def draw(i, j):
-        axes.plot([x[i],x[j]], [y[i], y[j]], [z[i], z[j]], color='black')
-    draw(0, 1)
-    draw(0, 2)
-    draw(0, 3)
-    draw(7, 4)
-    draw(7, 5)
-    draw(7, 6)
+    def _draw(i, j):
+        axes.plot([x[i], x[j]], [y[i], y[j]], [z[i], z[j]], color='black')
+    _draw(0, 1)
+    _draw(0, 2)
+    _draw(0, 3)
+    _draw(7, 4)
+    _draw(7, 5)
+    _draw(7, 6)
 
 def draw_parallelepiped(axes, size, view, jitter, steps=None,
                         color=(0.6, 1.0, 0.6), alpha=1):
-    """Draw a parallelepiped."""
+    """Draw a parallelepiped surface, with view and jitter."""
     a, b, c = size
     x = a*np.array([+1, -1, +1, -1, +1, -1, +1, -1])
@@ -224,16 +229,18 @@
     ])
 
-def draw_sphere(axes, radius=0.5, steps=25, center=(0,0,0), color='w', alpha=1.):
+def draw_sphere(axes, radius=0.5, steps=25,
+                center=(0, 0, 0), color='w', alpha=1.):
     """Draw a sphere"""
-    u = np.linspace(0, 2 * np.pi, steps)
-    v = np.linspace(0, np.pi, steps)
-
-    x = radius * np.outer(np.cos(u), np.sin(v)) + center[0]
-    y = radius * np.outer(np.sin(u), np.sin(v)) + center[1]
-    z = radius * np.outer(np.ones(np.size(u)), np.cos(v)) + center[2]
+    u = np.linspace(0, 2 * pi, steps)
+    v = np.linspace(0, pi, steps)
+
+    x = radius * np.outer(cos(u), sin(v)) + center[0]
+    y = radius * np.outer(sin(u), sin(v)) + center[1]
+    z = radius * np.outer(np.ones(np.size(u)), cos(v)) + center[2]
     axes.plot_surface(x, y, z, color=color, alpha=alpha)
     #axes.plot_wireframe(x, y, z)
 
 def draw_axes(axes, origin=(-1, -1, -1), length=(2, 2, 2)):
+    """Draw wireframe axes lines, with given origin and length"""
     x, y, z = origin
     dx, dy, dz = length
@@ -243,4 +250,9 @@
 
 def draw_person_on_sphere(axes, view, height=0.5, radius=0.5):
+    """
+    Draw a person on the surface of a sphere.
+
+    *view* indicates (latitude, longitude, orientation)
+    """
     limb_offset = height * 0.05
     head_radius = height * 0.10
@@ -259,7 +271,7 @@
 
     # circle for head
-    u = np.linspace(0, 2 * np.pi, 40)
-    x = head_radius * np.cos(u)
-    z = head_radius * np.sin(u) + head_height
+    u = np.linspace(0, 2 * pi, 40)
+    x = head_radius * cos(u)
+    z = head_radius * sin(u) + head_height
     _draw_part(x, z)
 
@@ -304,5 +316,5 @@
     dtheta, dphi, dpsi = jitter
     base = {'gaussian':3, 'rectangle':sqrt(3), 'uniform':1}[dist]
-    def steps(delta):
+    def _steps(delta):
         if views is None:
             n = max(3, min(25, 2*int(base*delta/5)))
@@ -310,7 +322,7 @@
             n = views
         return base*delta*np.linspace(-1, 1, n) if delta > 0 else [0.]
-    for theta in steps(dtheta):
-        for phi in steps(dphi):
-            for psi in steps(dpsi):
+    for theta in _steps(dtheta):
+        for phi in _steps(dphi):
+            for psi in _steps(dpsi):
                 w = project_weight(theta, phi, 1.0, 1.0)
                 if w > 0:
@@ -319,5 +331,5 @@
     for v in 'xyz':
         a, b, c = size
-        lim = np.sqrt(a**2 + b**2 + c**2)
+        lim = sqrt(a**2 + b**2 + c**2)
         getattr(axes, 'set_'+v+'lim')([-lim, lim])
         #getattr(axes, v+'axis').label.set_text(v)
@@ -390,5 +402,5 @@
         def _project(theta_i, phi_j, psi):
             latitude, longitude = theta_i, phi_j
-            return latitude, longitude, psi
+            return latitude, longitude, psi, 'xyz'
             #return Rx(phi_j)*Ry(theta_i)
         def _weight(theta_i, phi_j, w_i, w_j):
@@ -400,5 +412,5 @@
             longitude = phi_j/scale if abs(phi_j) < abs(scale)*180 else 0
             #print("(%+7.2f, %+7.2f) => (%+7.2f, %+7.2f)"%(theta_i, phi_j, latitude, longitude))
-            return latitude, longitude, psi
+            return latitude, longitude, psi, 'xyz'
             #return Rx(longitude)*Ry(latitude)
         def _project(theta_i, phi_j, w_i, w_j):
@@ -412,5 +424,5 @@
             #latitude, longitude = guyou_invert([theta_i], [phi_j])
             longitude, latitude = guyou_invert([phi_j], [theta_i])
-            return latitude, longitude, psi
+            return latitude, longitude, psi, 'xyz'
             #return Rx(longitude[0])*Ry(latitude[0])
         def _weight(theta_i, phi_j, w_i, w_j):
@@ -420,5 +432,5 @@
         def _project(theta_i, phi_j, psi):
             latitude = sqrt(theta_i**2 + phi_j**2)
-            longitude = degrees(np.arctan2(phi_j, theta_i))
+            longitude = degrees(arctan2(phi_j, theta_i))
             #print("(%+7.2f, %+7.2f) => (%+7.2f, %+7.2f)"%(theta_i, phi_j, latitude, longitude))
             return latitude, longitude, psi-longitude, 'zyz'
@@ -462,8 +474,8 @@
         def _project(theta_i, phi_j, psi):
             radius = min(1, sqrt(theta_i**2 + phi_j**2)/180)
-            latitude = 180-degrees(2*np.arccos(radius))
-            longitude = degrees(np.arctan2(phi_j, theta_i))
+            latitude = 180-degrees(2*arccos(radius))
+            longitude = degrees(arctan2(phi_j, theta_i))
             #print("(%+7.2f, %+7.2f) => (%+7.2f, %+7.2f)"%(theta_i, phi_j, latitude, longitude))
-            return latitude, longitude, psi, "zyz"
+            return latitude, longitude, psi, 'zyz'
             #R = Rz(longitude)*Ry(latitude)*Rz(psi)
             #return R_to_xyz(R)
@@ -487,8 +499,8 @@
     Based on: Shoemakeâs "Euler Angle Conversion", Graphics Gems IV, pp.  222-229
     """
-    phi = np.arctan2(R[1, 2], R[2, 2])
-    theta = np.arctan2(-R[0, 2], np.sqrt(R[0, 0]**2 + R[0, 1]**2))
-    psi = np.arctan2(R[0, 1], R[0, 0])
-    return np.degrees(phi), np.degrees(theta), np.degrees(psi)
+    phi = arctan2(R[1, 2], R[2, 2])
+    theta = arctan2(-R[0, 2], sqrt(R[0, 0]**2 + R[0, 1]**2))
+    psi = arctan2(R[0, 1], R[0, 0])
+    return degrees(phi), degrees(theta), degrees(psi)
 
 def draw_mesh(axes, view, jitter, radius=1.2, n=11, dist='gaussian',
@@ -502,7 +514,7 @@
     def _rotate(theta, phi, z):
         dview = _project(theta, phi, 0.)
-        if len(dview) == 4: # hack for zyz coords
+        if dview[3] == 'zyz':
             return Rz(dview[1])*Ry(dview[0])*z
-        else:
+        else:  # dview[3] == 'xyz':
             return Rx(dview[1])*Ry(dview[0])*z
 
@@ -657,42 +669,77 @@
 #orient_relative_to_beam = orient_relative_to_beam_quaternion
 
+# === Quaterion class definition === BEGIN
 # Simple stand-alone quaternion class
-import numpy as np
-from copy import copy
+
+# Note: this code works but isn't unused since quaternions didn't solve the
+# representation problem.  Leave it here in case we want to revisit this later.
+
+#import numpy as np
 class Quaternion(object):
+    r"""
+    Quaternion(w, r) = w + ir[0] + jr[1] + kr[2]
+
+    Quaternion.from_angle_axis(theta, r) for a rotation of angle theta about
+    an axis oriented toward the direction r.  This defines a unit quaternion,
+    normalizing $r$ to the unit vector $\hat r$, and setting quaternion
+    $Q = \cos \theta + \sin \theta \hat r$
+
+    Quaternion objects can be multiplied, which applies a rotation about the
+    given axis, allowing composition of rotations without risk of gimbal lock.
+    The resulting quaternion is applied to a set of points using *Q.rot(v)*.
+    """
     def __init__(self, w, r):
-         self.w = w
-         self.r = np.asarray(r, dtype='d')
+        self.w = w
+        self.r = np.asarray(r, dtype='d')
+
     @staticmethod
     def from_angle_axis(theta, r):
-         theta = np.radians(theta)/2
-         r = np.asarray(r)
-         w = np.cos(theta)
-         r = np.sin(theta)*r/np.dot(r,r)
-         return Quaternion(w, r)
+        """Build quaternion as rotation theta about axis r"""
+        theta = np.radians(theta)/2
+        r = np.asarray(r)
+        w = np.cos(theta)
+        r = np.sin(theta)*r/np.dot(r, r)
+        return Quaternion(w, r)
+
     def __mul__(self, other):
+        """Multiply quaterions"""
         if isinstance(other, Quaternion):
             w = self.w*other.w - np.dot(self.r, other.r)
             r = self.w*other.r + other.w*self.r + np.cross(self.r, other.r)
             return Quaternion(w, r)
+        raise NotImplementedError("Quaternion * non-quaternion not implemented")
+
     def rot(self, v):
+        """Transform point *v* by quaternion"""
         v = np.asarray(v).T
         use_transpose = (v.shape[-1] != 3)
-        if use_transpose: v = v.T
+        if use_transpose:
+            v = v.T
         v = v + np.cross(2*self.r, np.cross(self.r, v) + self.w*v)
         #v = v + 2*self.w*np.cross(self.r, v) + np.cross(2*self.r, np.cross(self.r, v))
-        if use_transpose: v = v.T
+        if use_transpose:
+            v = v.T
         return v.T
+
     def conj(self):
+        """Conjugate quaternion"""
         return Quaternion(self.w, -self.r)
+
     def inv(self):
+        """Inverse quaternion"""
         return self.conj()/self.norm()**2
+
     def norm(self):
+        """Quaternion length"""
         return np.sqrt(self.w**2 + np.sum(self.r**2))
+
     def __str__(self):
         return "%g%+gi%+gj%+gk"%(self.w, self.r[0], self.r[1], self.r[2])
+
 def test_qrot():
-    # Define rotation of 60 degrees around an axis in y-z that is 60 degrees from y.
-    # The rotation axis is determined by rotating the point [0, 1, 0] about x.
+    """Quaternion checks"""
+    # Define rotation of 60 degrees around an axis in y-z that is 60 degrees
+    # from y.  The rotation axis is determined by rotating the point [0, 1, 0]
+    # about x.
     ax = Quaternion.from_angle_axis(60, [1, 0, 0]).rot([0, 1, 0])
     q = Quaternion.from_angle_axis(60, ax)
@@ -704,4 +751,5 @@
 #test_qrot()
 #import sys; sys.exit()
+# === Quaterion class definition === END
 
 # translate between number of dimension of dispersity and the number of
@@ -725,14 +773,15 @@
     or the top of the range, depending on whether *mode* is 'central' or 'top'.
     """
-    if portion == 1.0:
-        return data.min(), data.max()
-    elif mode == 'central':
-        data = np.sort(data.flatten())
-        offset = int(portion*len(data)/2 + 0.5)
-        return data[offset], data[-offset]
-    elif mode == 'top':
-        data = np.sort(data.flatten())
-        offset = int(portion*len(data) + 0.5)
-        return data[offset], data[-1]
+    if portion < 1.0:
+        if mode == 'central':
+            data = np.sort(data.flatten())
+            offset = int(portion*len(data)/2 + 0.5)
+            return data[offset], data[-offset]
+        if mode == 'top':
+            data = np.sort(data.flatten())
+            offset = int(portion*len(data) + 0.5)
+            return data[offset], data[-1]
+    # Default: full range
+    return data.min(), data.max()
 
 def draw_scattering(calculator, axes, view, jitter, dist='gaussian'):
@@ -765,9 +814,9 @@
 
     # compute the pattern
-    qx, qy = calculator._data.x_bins, calculator._data.y_bins
+    qx, qy = calculator.qxqy
     Iqxy = calculator(**pars).reshape(len(qx), len(qy))
 
     # scale it and draw it
-    Iqxy = np.log(Iqxy)
+    Iqxy = log(Iqxy)
     if calculator.limits:
         # use limits from orientation (0,0,0)
@@ -781,12 +830,13 @@
     #qx, qy = np.meshgrid(qx, qy)
     if 0:
-        from matplotlib import cm
         level = np.asarray(255*(Iqxy - vmin)/(vmax - vmin), 'i')
         level[level < 0] = 0
+        from matplotlib import pylab as plt
         colors = plt.get_cmap()(level)
+        #from matplotlib import cm
         #colors = cm.coolwarm(level)
         #colors = cm.gist_yarg(level)
         #colors = cm.Wistia(level)
-        colors[level<=0, 3] = 0.  # set floor to transparent
+        colors[level <= 0, 3] = 0.  # set floor to transparent
         x, y = np.meshgrid(qx/qx.max(), qy/qy.max())
         axes.plot_surface(x, y, -1.1*np.ones_like(x), facecolors=colors)
@@ -822,4 +872,7 @@
     calculator = DirectModel(data, model)
 
+    # Remember the data axes so we can plot the results
+    calculator.qxqy = (q, q)
+
     # stuff the values for non-orientation parameters into the calculator
     calculator.pars = pars.copy()
@@ -829,5 +882,5 @@
     # under rotation or angular dispersion
     Iqxy = calculator(theta=0, phi=0, psi=0, **calculator.pars)
-    Iqxy = np.log(Iqxy)
+    Iqxy = log(Iqxy)
     vmin, vmax = clipped_range(Iqxy, 0.95, mode='top')
     calculator.limits = vmin, vmax+1
@@ -963,5 +1016,5 @@
     PLOT_ENGINE(calculator, draw_shape, size, view, jitter, dist, mesh, projection)
 
-def mpl_plot(calculator, draw_shape, size, view, jitter, dist, mesh, projection):
+def _mpl_plot(calculator, draw_shape, size, view, jitter, dist, mesh, projection):
     # Note: travis-ci does not support mpl_toolkits.mplot3d, but this shouldn't be
     # an issue since we are lazy-loading the package on a path that isn't tested.
@@ -1020,5 +1073,5 @@
 
     ## callback to draw the new view
-    def update(val, axis=None):
+    def _update(val, axis=None):
         view = stheta.val, sphi.val, spsi.val
         jitter = sdtheta.val, sdphi.val, sdpsi.val
@@ -1047,13 +1100,13 @@
 
     ## bind control widgets to view updater
-    stheta.on_changed(lambda v: update(v, 'theta'))
-    sphi.on_changed(lambda v: update(v, 'phi'))
-    spsi.on_changed(lambda v: update(v, 'psi'))
-    sdtheta.on_changed(lambda v: update(v, 'dtheta'))
-    sdphi.on_changed(lambda v: update(v, 'dphi'))
-    sdpsi.on_changed(lambda v: update(v, 'dpsi'))
+    stheta.on_changed(lambda v: _update(v, 'theta'))
+    sphi.on_changed(lambda v: _update(v, 'phi'))
+    spsi.on_changed(lambda v: _update(v, 'psi'))
+    sdtheta.on_changed(lambda v: _update(v, 'dtheta'))
+    sdphi.on_changed(lambda v: _update(v, 'dphi'))
+    sdpsi.on_changed(lambda v: _update(v, 'dpsi'))
 
     ## initialize view
-    update(None, 'phi')
+    _update(None, 'phi')
 
     ## go interactive
@@ -1062,4 +1115,11 @@
 
 def map_colors(z, kw):
+    """
+    Process matplotlib-style colour arguments.
+
+    Pulls 'cmap', 'alpha', 'vmin', and 'vmax' from th *kw* dictionary, setting
+    the *kw['color']* to an RGB array.  These are ignored if 'c' or 'color' are
+    set inside *kw*.
+    """
     from matplotlib import cm
 
@@ -1083,8 +1143,10 @@
 
 def make_vec(*args):
+    """Turn all elements of *args* into numpy arrays"""
     #return [np.asarray(v, 'd').flatten() for v in args]
     return [np.asarray(v, 'd') for v in args]
 
 def make_image(z, kw):
+    """Convert numpy array *z* into a *PIL* RGB image."""
     import PIL.Image
     from matplotlib import cm
@@ -1113,5 +1175,5 @@
     'b': 'blue',
 }
-def ipv_fix_color(kw):
+def _ipv_fix_color(kw):
     alpha = kw.pop('alpha', None)
     color = kw.get('color', None)
@@ -1132,5 +1194,5 @@
             kw['color'] = color
 
-def ipv_set_transparency(kw, obj):
+def _ipv_set_transparency(kw, obj):
     color = kw.get('color', None)
     if (isinstance(color, np.ndarray)
@@ -1141,7 +1203,13 @@
 
 def ipv_axes():
+    """
+    Build a matplotlib style Axes interface for ipyvolume
+    """
     import ipyvolume as ipv
 
-    class Plotter:
+    class Axes:
+        """
+        Matplotlib Axes3D style interface to ipyvolume renderer.
+        """
         # transparency can be achieved by setting the following:
         #    mesh.color = [r, g, b, alpha]
@@ -1156,27 +1224,31 @@
         # maybe need to synchronize update of x/y/z to avoid shimmy when moving
         def plot(self, x, y, z, **kw):
-            ipv_fix_color(kw)
+            """mpl style plot interface for ipyvolume"""
+            _ipv_fix_color(kw)
             x, y, z = make_vec(x, y, z)
             ipv.plot(x, y, z, **kw)
         def plot_surface(self, x, y, z, **kw):
+            """mpl style plot_surface interface for ipyvolume"""
             facecolors = kw.pop('facecolors', None)
             if facecolors is not None:
                 kw['color'] = facecolors
-            ipv_fix_color(kw)
+            _ipv_fix_color(kw)
             x, y, z = make_vec(x, y, z)
             h = ipv.plot_surface(x, y, z, **kw)
-            ipv_set_transparency(kw, h)
+            _ipv_set_transparency(kw, h)
             #h.material.side = "DoubleSide"
             return h
         def plot_trisurf(self, x, y, triangles=None, Z=None, **kw):
+            """mpl style plot_trisurf interface for ipyvolume"""
             kw.pop('linewidth', None)
-            ipv_fix_color(kw)
+            _ipv_fix_color(kw)
             x, y, z = make_vec(x, y, Z)
             if triangles is not None:
                 triangles = np.asarray(triangles)
             h = ipv.plot_trisurf(x, y, z, triangles=triangles, **kw)
-            ipv_set_transparency(kw, h)
+            _ipv_set_transparency(kw, h)
             return h
         def scatter(self, x, y, z, **kw):
+            """mpl style scatter interface for ipyvolume"""
             x, y, z = make_vec(x, y, z)
             map_colors(z, kw)
@@ -1184,10 +1256,12 @@
             kw['marker'] = _IPV_MARKERS.get(marker, marker)
             h = ipv.scatter(x, y, z, **kw)
-            ipv_set_transparency(kw, h)
+            _ipv_set_transparency(kw, h)
             return h
         def contourf(self, x, y, v, zdir='z', offset=0, levels=None, **kw):
+            """mpl style contourf interface for ipyvolume"""
             # Don't use contour for now (although we might want to later)
             self.pcolor(x, y, v, zdir='z', offset=offset, **kw)
         def pcolor(self, x, y, v, zdir='z', offset=0, **kw):
+            """mpl style pcolor interface for ipyvolume"""
             x, y, v = make_vec(x, y, v)
             image = make_image(v, kw)
@@ -1200,22 +1274,29 @@
             v = np.array([[0., 0], [1, 1]])
             h = ipv.plot_mesh(x, y, z, u=u, v=v, texture=image, wireframe=False)
-            ipv_set_transparency(kw, h)
+            _ipv_set_transparency(kw, h)
             h.material.side = "DoubleSide"
             return h
         def text(self, *args, **kw):
+            """mpl style text interface for ipyvolume"""
             pass
         def set_xlim(self, limits):
+            """mpl style set_xlim interface for ipyvolume"""
             ipv.xlim(*limits)
         def set_ylim(self, limits):
+            """mpl style set_ylim interface for ipyvolume"""
             ipv.ylim(*limits)
         def set_zlim(self, limits):
+            """mpl style set_zlim interface for ipyvolume"""
             ipv.zlim(*limits)
         def set_axes_on(self):
+            """mpl style set_axes_on interface for ipyvolume"""
             ipv.style.axis_on()
         def set_axis_off(self):
+            """mpl style set_axes_off interface for ipyvolume"""
             ipv.style.axes_off()
-    return Plotter()
-
-def ipv_plot(calculator, draw_shape, size, view, jitter, dist, mesh, projection):
+    return Axes()
+
+def _ipv_plot(calculator, draw_shape, size, view, jitter, dist, mesh, projection):
+    from IPython.display import display
     import ipywidgets as widgets
     import ipyvolume as ipv
@@ -1223,5 +1304,5 @@
     axes = ipv_axes()
 
-    def draw(view, jitter):
+    def _draw(view, jitter):
         camera = ipv.gcf().camera
         #print(ipv.gcf().__dict__.keys())
@@ -1271,8 +1352,8 @@
     #widgets.interact(update, Îž=trange, Ï=prange, Ï=prange, ÎÎž=dtrange, ÎÏ=dprange, ÎÏ=dprange)
 
-    def update(theta, phi, psi, dtheta, dphi, dpsi):
-        draw(view=(theta, phi, psi), jitter=(dtheta, dphi, dpsi))
-
-    def slider(name, slice, init=0.):
+    def _update(theta, phi, psi, dtheta, dphi, dpsi):
+        _draw(view=(theta, phi, psi), jitter=(dtheta, dphi, dpsi))
+
+    def _slider(name, slice, init=0.):
         return widgets.FloatSlider(
             value=init,
@@ -1288,10 +1369,10 @@
             readout_format='.1f',
             )
-    theta = slider(u'Îž', trange, view[0])
-    phi = slider(u'Ï', prange, view[1])
-    psi = slider(u'Ï', prange, view[2])
-    dtheta = slider(u'ÎÎž', dtrange, jitter[0])
-    dphi = slider(u'ÎÏ', dprange, jitter[1])
-    dpsi = slider(u'ÎÏ', dprange, jitter[2])
+    theta = _slider(u'Îž', trange, view[0])
+    phi = _slider(u'Ï', prange, view[1])
+    psi = _slider(u'Ï', prange, view[2])
+    dtheta = _slider(u'ÎÎž', dtrange, jitter[0])
+    dphi = _slider(u'ÎÏ', dprange, jitter[1])
+    dpsi = _slider(u'ÎÏ', dprange, jitter[2])
     fields = {
         'theta': theta, 'phi': phi, 'psi': psi,
@@ -1303,21 +1384,27 @@
     ])
 
-    out = widgets.interactive_output(update, fields)
+    out = widgets.interactive_output(_update, fields)
     display(ui, out)
 
 
 _ENGINES = {
-    "matplotlib": mpl_plot,
-    "mpl": mpl_plot,
-    #"plotly": plotly_plot,
-    "ipvolume": ipv_plot,
-    "ipv": ipv_plot,
+    "matplotlib": _mpl_plot,
+    "mpl": _mpl_plot,
+    #"plotly": _plotly_plot,
+    "ipvolume": _ipv_plot,
+    "ipv": _ipv_plot,
 }
 PLOT_ENGINE = _ENGINES["matplotlib"]
 def set_plotter(name):
+    """
+    Setting the plotting engine to matplotlib/ipyvolume or equivalently mpl/ipv.
+    """
     global PLOT_ENGINE
     PLOT_ENGINE = _ENGINES[name]
 
 def main():
+    """
+    Command line interface to the jitter viewer.
+    """
     parser = argparse.ArgumentParser(
         description="Display jitter",
Index: sasmodels/kernel.py
===================================================================
--- sasmodels/kernel.py	(revision 3199b177cb91c6bd74017b7f942ddbbbc9bb46c0)
+++ sasmodels/kernel.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -25,21 +25,41 @@
 
 class KernelModel(object):
+    """
+    Model definition for the compute engine.
+    """
     info = None  # type: ModelInfo
     dtype = None # type: np.dtype
     def make_kernel(self, q_vectors):
         # type: (List[np.ndarray]) -> "Kernel"
+        """
+        Instantiate a kernel for evaluating the model at *q_vectors*.
+        """
         raise NotImplementedError("need to implement make_kernel")
 
     def release(self):
         # type: () -> None
+        """
+        Free resources associated with the kernel.
+        """
         pass
 
 
 class Kernel(object):
-    #: kernel dimension, either "1d" or "2d"
+    """
+    Instantiated model for the compute engine, applied to a particular *q*.
+
+    Subclasses should define :meth:`_call_kernel` to evaluate the kernel over
+    its inputs.
+    """
+    #: Kernel dimension, either "1d" or "2d".
     dim = None  # type: str
+    #: Model info.
     info = None  # type: ModelInfo
-    results = None # type: List[np.ndarray]
+    #: Numerical precision for the computation.
     dtype = None  # type: np.dtype
+    #: q values at which the kernel is to be evaluated
+    q_input = None  # type: Any
+    #: Place to hold result of :meth:`_call_kernel` for subclass.
+    result = None # type: np.ndarray
 
     def Iq(self, call_details, values, cutoff, magnetic):
@@ -57,6 +77,6 @@
         built into the model, and do not need an additional scale.
         """
-        _, F2, _, shell_volume, _ = self.Fq(call_details, values, cutoff, magnetic,
-                              effective_radius_type=0)
+        _, F2, _, shell_volume, _ = self.Fq(call_details, values, cutoff,
+                                            magnetic, effective_radius_type=0)
         combined_scale = values[0]/shell_volume
         background = values[1]
@@ -64,5 +84,6 @@
     __call__ = Iq
 
-    def Fq(self, call_details, values, cutoff, magnetic, effective_radius_type=0):
+    def Fq(self, call_details, values, cutoff, magnetic,
+           effective_radius_type=0):
         # type: (CallDetails, np.ndarray, np.ndarray, float, bool, int) -> np.ndarray
         r"""
@@ -81,5 +102,5 @@
         .. math::
 
-            I(q) = \text{scale} * P (1 + <F>^2/<F^2> (S - 1)) + \text{background}
+            I(q) = \text{scale} P (1 + <F>^2/<F^2> (S - 1)) + \text{background}
                  = \text{scale}/<V> (<F^2> + <F>^2 (S - 1)) + \text{background}
 
@@ -90,5 +111,5 @@
         .. math::
 
-            P(q) = \frac{\sum w_k F^2(q, x_k) / \sum w_k}{\sum w_k V_k / \sum w_k}
+            P(q)=\frac{\sum w_k F^2(q, x_k) / \sum w_k}{\sum w_k V_k / \sum w_k}
 
         The form factor itself is scaled by volume and contrast to compute the
@@ -131,5 +152,6 @@
         hollow and solid shapes.
         """
-        self._call_kernel(call_details, values, cutoff, magnetic, effective_radius_type)
+        self._call_kernel(call_details, values, cutoff, magnetic,
+                          effective_radius_type)
         #print("returned",self.q_input.q, self.result)
         nout = 2 if self.info.have_Fq and self.dim == '1d' else 1
@@ -146,5 +168,6 @@
         if shell_volume == 0.:
             shell_volume = 1.
-        F1 = self.result[1:nout*self.q_input.nq:nout]/total_weight if nout == 2 else None
+        F1 = (self.result[1:nout*self.q_input.nq:nout]/total_weight
+              if nout == 2 else None)
         F2 = self.result[0:nout*self.q_input.nq:nout]/total_weight
         return F1, F2, effective_radius, shell_volume, form_volume/shell_volume
@@ -152,7 +175,11 @@
     def release(self):
         # type: () -> None
+        """
+        Free resources associated with the kernel instance.
+        """
         pass
 
-    def _call_kernel(self, call_details, values, cutoff, magnetic, effective_radius_type):
+    def _call_kernel(self, call_details, values, cutoff, magnetic,
+                     effective_radius_type):
         # type: (CallDetails, np.ndarray, np.ndarray, float, bool, int) -> np.ndarray
         """
Index: sasmodels/kernelcl.py
===================================================================
--- sasmodels/kernelcl.py	(revision 3199b177cb91c6bd74017b7f942ddbbbc9bb46c0)
+++ sasmodels/kernelcl.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -53,4 +53,5 @@
 from __future__ import print_function
 
+import sys
 import os
 import warnings
@@ -61,5 +62,4 @@
     from time import perf_counter as clock
 except ImportError: # CRUFT: python < 3.3
-    import sys
     if sys.platform.count("darwin") > 0:
         from time import time as clock
@@ -99,4 +99,5 @@
 # CRUFT: pyopencl < 2017.1 (as of June 2016 needs quotes around include path).
 def quote_path(v):
+    # type: (str) -> str
     """
     Quote the path if it is not already quoted.
@@ -110,11 +111,12 @@
 
 def fix_pyopencl_include():
+    # type: (None) -> None
     """
     Monkey patch pyopencl to allow spaces in include file path.
     """
-    import pyopencl as cl
-    if hasattr(cl, '_DEFAULT_INCLUDE_OPTIONS'):
-        cl._DEFAULT_INCLUDE_OPTIONS = [
-            quote_path(v) for v in cl._DEFAULT_INCLUDE_OPTIONS
+    import pyopencl
+    if hasattr(pyopencl, '_DEFAULT_INCLUDE_OPTIONS'):
+        pyopencl._DEFAULT_INCLUDE_OPTIONS = [
+            quote_path(v) for v in pyopencl._DEFAULT_INCLUDE_OPTIONS
             ]
 
@@ -147,4 +149,6 @@
 
 def use_opencl():
+    # type: () -> bool
+    """Return True if OpenCL is the default computational engine"""
     sas_opencl = os.environ.get("SAS_OPENCL", "OpenCL").lower()
     return HAVE_OPENCL and sas_opencl != "none" and not sas_opencl.startswith("cuda")
@@ -153,4 +157,5 @@
 ENV = None
 def reset_environment():
+    # type: () -> None
     """
     Call to create a new OpenCL context, such as after a change to SAS_OPENCL.
@@ -323,8 +328,10 @@
             return [cl.create_some_context(interactive=False)]
         except Exception as exc:
+            # TODO: Should warnings instead by put into logging.warn?
             warnings.warn(str(exc))
-            warnings.warn("pyopencl.create_some_context() failed.  The "
-                "environment variable 'SAS_OPENCL' or 'PYOPENCL_CTX' might "
-                "not be set correctly")
+            warnings.warn(
+                "pyopencl.create_some_context() failed.  The environment "
+                "variable 'SAS_OPENCL' or 'PYOPENCL_CTX' might not be set "
+                "correctly")
 
     return _get_default_context()
Index: sasmodels/kernelcuda.py
===================================================================
--- sasmodels/kernelcuda.py	(revision fa26e7834aa4332ef6ffc8eaf2a64c9ea1b51a64)
+++ sasmodels/kernelcuda.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -59,5 +59,4 @@
 
 import os
-import warnings
 import logging
 import time
@@ -110,4 +109,6 @@
 
 def use_cuda():
+    # type: None -> bool
+    """Returns True if CUDA is the default compute engine."""
     sas_opencl = os.environ.get("SAS_OPENCL", "CUDA").lower()
     return HAVE_CUDA and sas_opencl.startswith("cuda")
@@ -136,5 +137,5 @@
         if not HAVE_CUDA:
             raise RuntimeError("CUDA startup failed with ***"
-                            + CUDA_ERROR + "***; using C compiler instead")
+                               + CUDA_ERROR + "***; using C compiler instead")
         reset_environment()
         if ENV is None:
@@ -198,5 +199,6 @@
     """
     for match in FUNCTION_PATTERN.finditer(source):
-        print(match.group('qualifiers').replace('\n',r'\n'), match.group('function'), '(')
+        print(match.group('qualifiers').replace('\n', r'\n'),
+              match.group('function'), '(')
     return source
 
@@ -260,4 +262,5 @@
 
     def release(self):
+        """Free the CUDA device associated with this context."""
         if self.context is not None:
             self.context.pop()
Index: sasmodels/kerneldll.py
===================================================================
--- sasmodels/kerneldll.py	(revision 3199b177cb91c6bd74017b7f942ddbbbc9bb46c0)
+++ sasmodels/kerneldll.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -174,5 +174,5 @@
 
 
-def compile(source, output):
+def compile_model(source, output):
     # type: (str, str) -> None
     """
@@ -265,5 +265,5 @@
         with os.fdopen(system_fd, "w") as file_handle:
             file_handle.write(source)
-        compile(source=filename, output=dll)
+        compile_model(source=filename, output=dll)
         # Comment the following to keep the generated C file.
         # Note: If there is a syntax error then compile raises an error
